function [F, pvalF] = Ftest(y, XX, group0, group1)

% Eqn 3.13 from "Elements of statistical learning" p46

[n d] = size(XX);
X = [ones(n,1) XX(:,group0)];
w0 = X\y;
rss0 = sum( (y-X*w0).^2 );
d0 = length(w0)-1;
X = [ones(n,1) XX(:,group1)];
w1 = X\y;
rss1 = sum( (y-X*w1).^2 );
d1 = length(w1)-1;
F = ((rss0-rss1)/(d1-d0)) / (rss1/(n-d1-1));
pvalF = 1-fcdf(F,d1-d0,n-d1-1);
