function a = dirichletMomentMatch(p)
% Method of moments estimate for Dirichlet parameters
% Each row of p is a multivariate observation on the probability simplex.
% Written by Tom Minka

a = mean(p);
thres = 1e3;
for k = 1:length(a)
  m2 = var(p(k,:));
  s = (a(k) - m2) / (m2 - a(k)^2);
  if (s > 0) & (s < thres)
    a = a*s;
    break
  end
end
if (s < 0) | (s >= thres)
  a = a*thres;
end
