% dirichletPlot3d
% Based on code by Jonathan Huang http://www.cs.cmu.edu/~jch1/research/dirichlet/

%alpha=[ 20 20 20];
%alpha=[2 2 2];
alpha=[20 2 2];


% compute a fine triangulation of 2-simplex
res=200;
map=zeros(res^2/2,1);
tris = zeros(res^2/2,3);
tris2d = zeros(res^2/2,2);
indices = zeros(res^2,3);
pts = zeros(res^2,3);
p=[0 0 1];
u = 0;
v = 1;
counter=0;
for i=1:res
    for j=1:res-i
        counter=counter+1;
        u = i/res;
        v = j/res;
        p = [u v 1-u-v];
        pts(counter,:)=p;
        tris2d(counter,:)=[u v];
        tris(counter,:)=p;
	map(counter) = prod(p.^(alpha-1));
    end
end
tris=tris(1:counter,:);
tris2d=tris2d(1:counter,:);
pts=pts(1:counter,:);
D=delaunay(tris2d(:,1),tris2d(:,2));
map=255*(map(1:counter)/max(map));

MYFIG=figure;
hold on;
campos([2 2 2]);
camtarget([0 0 0]);
trisurf(D,tris(:,1),tris(:,2),tris(:,3),'LineStyle','none', ...
        'Cdata',map,'FaceColor','interp');
grid on
title(sprintf('Dir(%d,%d,%d)', alpha(1), alpha(2), alpha(3)))

fname = sprintf('C:/kmurphy/figures/other/dirichlet%d_%d_%d.eps', alpha(1), alpha(2), alpha(3))
print(gcf, fname, '-depsc')
