function [muAgivenB, SigmaAgivenB] = gaussCondition(mu, Sigma, a, x)
% Compute p(Xa|Xb=x(b)) = N(Xa|muAgivenB, SigmaAgivenB)
% Here x is a vector of all d values, and b = (1:d) \ a
% SigmaAgivenB is a covariance matrix (in the scalar case, the conditional variance)

d = length(mu);
mu = mu(:); x = x(:);
b = setdiff(1:d, a);
muA = mu(a); muB = mu(b);
SAA = Sigma(a,a);
SAB = Sigma(a,b);
SBB = Sigma(b,b);
SBBinv = inv(SBB);
muAgivenB = mu(a) + SAB*SBBinv*(x(b)-mu(b));
SigmaAgivenB = SAA - SAB*SBBinv*SAB';
