function [post, lik] = gaussianClassifierApply(Xtest, params);
% gaussianClassifierApply - apply Bayes rule with Gaussian class-conditioanl densities.
% Computes post(i,c) = P(C=c|x(i,:)) using full untied covariance matrices

Ntest = size(Xtest,1);
Nclasses = length(params.classPrior);
lik = zeros(Ntest, Nclasses);
for c=1:Nclasses
  %lik(:,c) = mvnpdf(Xtest, params.mu(:, c)', params.Sigma(:,:, c));
  lik(:,c) = gausspdf(Xtest, params.mu(:, c)', params.Sigma(:,:, c));
end
classPrior = params.classPrior;
N = size(Xtest,1);
logjoint = log(lik) + repmat(log(classPrior(:)'), N, 1);
logpost = logjoint - repmat(logsumexp(logjoint,2), 1, Nclasses);
post = exp(logpost);


