function data = heightWeightDataLoad()

% height/weight data from http://www.stat.psu.edu/~resources/bydata.htm
% Simplified using heightWeightDataCleanup.m

rawdata = dlmread('heightWeightDataSimple.txt'); % comma delimited file
data.Y = rawdata(:,1); % 1=male, 2=female
data.X = [rawdata(:,2) rawdata(:,3)]; % height, weight
data.featureNames = {'height ', 'weight'};
data.classNames = {'male', 'female'}; % 1,2 
Nclasses = 2;
Ndims = 2;
maleClass = find(strcmp(data.classNames, 'male'));
femaleClass = find(strcmp(data.classNames, 'female'));


