% heightWeightDataPlot
% Make 2D scatter plot and superimpose Gaussian fit

data = heightWeightDataLoad;


figure(1); clf
maleNdx = find(data.Y == 1);
femaleNdx = find(data.Y == 2);
scatter(data.X(maleNdx,1), data.X(maleNdx,2), 10, 'bx');
hold on
scatter(data.X(femaleNdx,1), data.X(femaleNdx,2), 10, 'ro');
xlabel('height')
ylabel('weight')
title('red = female, blue=male')

colors = 'br';
mu = zeros(2,2);
Sigma = zeros(2,2,2);
classNdx = {maleNdx, femaleNdx};
for c=1:2
  mu(:,c)  = mean(data.X(classNdx{c},:))';
  Sigma(:,:,c)  = cov(data.X(classNdx{c},:),1);
  hold on
  plot2dgauss(mu(:,c), Sigma(:,:,c), colors(c));
end

