% precision ~ G(a,b) so
% sigma^2 ~ IG(a,b^-1)
% http://en.wikipedia.org/wiki/Inverse-gamma_distribution
% plot this as a fn of b with a=1

figure(1);clf
xs = 0.01:0.01:3;
as = [1:4];
bs = [0.5 1 1.5 2];
A = length(as); B = length(bs);
for ai=1:A
  a = as(ai);
  for bi=1:B
    b = bs(bi);
    subplot2(A,B,ai,bi);
    precision = gampdf(xs,a,b); % gamma
    plot(xs, precision)
    %hold on
    %variance = gampdf(xs,a,1/b); % inverse gamma
    %plot(1./xs, variance,  'r')
    title(sprintf('a=%3.1f, b=%3.1f', a, b))
  end
end


figure(2);clf
xs = 1./(0.01:0.01:3);
A = length(as); B = length(bs);
for ai=1:A
  a = as(ai);
  for bi=1:B
    b = bs(bi);
    subplot2(A,B,ai,bi);
    %precision = gampdf(xs,a,b); % gamma
    %plot(xs, variance)
    %hold on
    variance = gampdf(xs,a,1/b); % inverse gamma(a,b)
    plot(1./xs, variance,  'r')
    title(sprintf('a=%3.1f, b=%3.1f', a, b))
  end
end
