% invchi2plot

figure(1);clf;
sigma2s  = 0.01:0.01:2;

nu0 = [1 50 1 50];
sigma20 = [1 1 0.5 0.5];

for i=1:4
  p = invchi2pdf(sigma2s(:), nu0(i), sigma20(i));
  subplot(2,2,i)
  plot(sigma2s, p, 'linewidth', 2)
  str=sprintf('%s(%s=%2.1f, %s=%2.1f)',...
	      '\chi^{-2}', '\nu_0', nu0(i), '\sigma^2_0', sigma20(i));
  title(str)
end


figure(1);clf;
sigma2s  = 0.01:0.01:2;
nu0 = [1 1 1  5 5 5 ];
sigma20 = [0.1 1 2  0.1 1 2];
for i=1:6
  p = invchi2pdf(sigma2s(:), nu0(i), sigma20(i));
  subplot(2,3,i)
  plot(sigma2s, p, 'linewidth', 2)
  str=sprintf('%s(%s=%2.1f, %s=%2.1f)',...
	      '\chi^{-2}', '\nu', nu0(i), '\sigma^2', sigma20(i));
  title(str)
  set(gca,'xlim',[-0.1 2])
end



% Inverse chi2
figure(3);clf;
xs = 0:0.05:2;
nu = [1 1 1  5 5 5];
sigma = [0.5 1 2  0.5 1 2];
clear legendStr
styles = plotColors;
for i=1:length(a)
  p = invchi2pdf(xs, nu(i), sigma(i));
  plot(xs,p, styles{i});
  hold on
  legendStr{i} =  sprintf('%s=%4.2f, %s=%4.2f', ...
			  '\nu', nu(i), '\sigma^2', sigma(i));
end
legend(legendStr)
title(sprintf('%s(%s,%s)', '\chi^{-2}', '\nu', '\sigma^2'))


% Inverse gamma
figure(2);clf;
xs = 0:0.05:2;
a = [0.1 1 2  0.1 1 2];
b = [1   1  1 2   2  2];
clear legendStr
styles = plotColors;
for i=1:length(a)
  p = invgammapdf(xs, a(i), b(i));
  plot(xs,p, styles{i});
  hold on
  legendStr{i} =  sprintf('a=%4.2f, b=%4.2f', a(i), b(i));
end
legend(legendStr)
title('IG(a,b)')




if 0
% Inverse gamma
figure(3);clf;
xs = 0:0.01:2;
a = [0 0.01 1 5]
b = [0 0.01 1 1]
for i=1:4
  p = invgammapdf(xs, a(i), b(i));
  subplot(2,2,i)
  plot(xs,p, 'linewidth', 2);
  title(sprintf('a=%4.2f, b=%4.2f', a(i), b(i)))
end
end
