function val = logpostJohnson(xy)
% Smoking/cancer example from Johnson and Albert p51 (data on p35)

% xy(:,i) is i'th param vector (alpha, eta)
data.y1 = 83; data.n1 = 86; data.y2 = 72; data.n2 = 86;
alpha=xy(1,:);   eta=xy(2,:);
t1 = (alpha+eta)/2; t2 = (eta-alpha)/2;
val = data.y1*t1 - data.n1*log(1+exp(t1)) ...
      + data.y2*t2 - data.n2*log(1+exp(t2));
