function [x,C,logZ] = laplaceApprox(logpost, start, niter, args, gradFn, hessFn)
% Laplace approximation to the log posterior.

% Find mode
x = start;
for i=1:niter
  H = hessFn(x, args);
  g = gradFn(x, args);
  C = -inv(H);
  x = x + C*g; % Newton step
end

% Gaussian approximation
ndim = length(x); 
logZ = ndim/2*log(2*pi) + 0.5*logdet(C) + feval(logpost, x, args{:});





