
% P(x.mu|x) propto p(x|x.mu, x.sigma) p(x.mu | mu.mu, mu.sigma)
dmu = 0.001;
mus = -3:dmu:3;

% Gaussian prior on x_mu
mu_mu = 0;
mu_sigma2 = 1;

% Gaussian lik
x_sigma2 = 1;

% data
xs = [0.5 1 1.5 3];
Ntrials = length(xs);

figure(1);clf
for trial=1:Ntrials
  x = xs(trial);


for i=1:length(mus)
  x_mu = mus(i);
  prior(i) = normpdf(x_mu, mu_mu, sqrt(mu_sigma2));
  lik(i) = normpdf(x, x_mu, sqrt(x_sigma2));
end
post = normalize(prior .* lik);

% exact analysis
N = 1;
mu_mle = x;
sigmaN2 = 1/(N/x_sigma2 + 1/mu_sigma2);
muN = sigmaN2*(mu_mu/mu_sigma2 + mu_mle/x_sigma2);
postExact = normpdf(mus, muN, sqrt(sigmaN2));

% Laplace version
% p(x.mu)  = lambda/2 exp(-lambda |x.mu|)
mu_lambda = 1;

for i=1:length(mus)
  x_mu = mus(i);
  priorLaplace(i) = (mu_lambda/2) * exp(-mu_lambda * abs(x_mu));
  lik(i) = normpdf(x, x_mu, sqrt(x_sigma2));
end
postLaplace = normalize(priorLaplace .* lik);

subplot2(Ntrials, 2, trial, 1);
delta = dmu;
plot(mus, normalize(prior)./delta, 'r-');
hold on
plot(mus, normalize(lik)./delta, 'g-');
plot(mus, post./delta, 'b-');
%plot(mus, postExact, 'k:');
%legend('prior', 'lik', 'post')
[pmode mode] = max(post./delta);
muMAP = mus(mode);
line([muMAP muMAP], [0 pmode]);
title(sprintf('Gaussian prior, x=%5.3f, MAP=%5.3f', x, muMAP));

subplot2(Ntrials, 2, trial, 2);
delta = dmu;
plot(mus, normalize(priorLaplace)./delta, 'r-');
hold on
plot(mus, normalize(lik)./delta, 'g-');
plot(mus, postLaplace./delta, 'b-');
%legend('prior', 'lik', 'post')
[pmode mode] = max(postLaplace./delta);
muMAP = mus(mode);
line([muMAP muMAP], [0 pmode]);
title(sprintf('Laplace prior, x=%5.3f, MAP=%5.3f', x, muMAP));

end % next trial
