function [xTrain, xTest, xTrainRaw, xTestRaw, yTrain, yTestOpt, RBFcenters] = linRegDemoMakeData()

RBFcenters = [];
seed = 0;
randn('state', seed);
rand('state', seed);
useRBF = 1;
doSave = 0;
doStandardize = 1

%  xTrainRaw = [-1:0.1:-0.5,3:0.1:3.5]'+0;
xTrainRaw = [-5:0.5:5]';
xTestRaw = [-5:0.1:5]';

noiseLevel = 5;
yTrain = feval(@fun, xTrainRaw) + randn(size(xTrainRaw,1),1)*noiseLevel;
yTestOpt = feval(@fun, xTestRaw);


if useRBF
  lo = min( min(xTrainRaw), min(xTestRaw) );
  hi = min( max(xTrainRaw), max(xTestRaw) );
  RBFcenters = linspace(lo, hi, 5)'
  %RBFcenters = linspace(-5, 5, 5)';
  xTrain = rbfBasis(xTrainRaw, RBFcenters);
  xTest = rbfBasis(xTestRaw, RBFcenters);
else
  xTrain = polyBasis(xTrainRaw, 2);
  xTest = polyBasis(xTestRaw, 2);
end

%if useRBF 
%  doStandardize = 0;
%end

if doStandardize
  [xTrain, muTrain, sigmaTrain] = standardizeCols(xTrain);
  [xTest] = standardizeCols(xTest, muTrain, sigmaTrain);
end
% add constant term
xTrain = [ones(size(xTrain,1),1) xTrain];
xTest = [ones(size(xTest,1),1) xTest];

%%%%%%%%

function f = fun(x) %target function
f = 10 + x + x.^3;
%f = 10 + x + x.^2;
%f = x.^4;

