function [xTrain, xTest, xTrainRaw, xTestRaw, yTrain, yTestOpt] = linRegDemoMakeDataOld()


seed = 0;
randn('state', seed);
rand('state', seed);
useRBF = 0;
doSave = 0;
longRange = 1;
doStandardize = 1
narrowTrain = 0;

if longRange
  if narrowTrain
    xTrainRaw = [-9:trainStep:-8, 3:trainStep:3.5]'+0;
  else   
    xTrainRaw = [-10:1:10]';
  end 
  xTestRaw = [-10:0.5:10]'+0;
else
  if narrowTrain
    xTrainRaw = [-1:0.1:-0.5,3:0.1:3.5]'+0;
  else    
    xTrainRaw = [-5:0.5:5]';
  end
  xTestRaw = [-2:0.1:4.5]'+0;
end

noiseLevel = 1;
yTrain = feval(@fun, xTrainRaw) + randn(size(xTrainRaw,1),1)*noiseLevel;
yTestOpt = feval(@fun, xTestRaw);

if doStandardize
  % We must standardize before doing an RBF expansion.
  % For polynomial basis, we can standardize before or afterwords.
  [xTrain, muTrain, sigmaTrain] = standardizeCols(xTrainRaw);
  [xTest] = standardizeCols(xTestRaw, muTrain, sigmaTrain);
else
  xTrain = xTrainRaw;
  xTest = xTestRaw;
end

if useRBF
  lo = min( min(xTrain), min(xTest) );
  hi = min( max(xTrain), max(xTest) );
  RBFcenters = linspace(lo, hi, 5)'
  %RBFcenters = linspace(-5, 5, 5)';
  xTrain = rbfBasis(xTrain, RBFcenters);
  xTest = rbfBasis(xTest, RBFcenters);
else
  xTrain = polyBasis(xTrain, 2);
  xTest = polyBasis(xTest, 2);
end

%xTrain = [ones(size(xTrain,1), 1) xTrain];
%xTest = [ones(size(xTest,1), 1) xTest];

%%%%%%%%

function f = fun(x) %target function
%f = 10 + x + x.^4;
f = 10 + x + x.^2;
%f = x.^4;

