% linRegDemoPoly
% produces same results as polytool in stats toolbox, without the GUI
load polydata % x, y, from stats toolbox
n = length(y);
x = x(:); y = y(:);
deg = 3;
X = [ones(n,1) polyBasis(x, deg)];
w = X\y(:);

xtest = 0:0.1:10; xtest = xtest(:);
ntest = length(xtest);
Xtest = [ones(ntest,1) polyBasis(xtest, deg)];
ypred = Xtest*w;

figure(deg);clf
plot(xtest, ypred, 'g-');
set(gca,'xlim',[-0.5 10.5]);
hold on
plot(x, y, '+')

% plot confidence interval on f(x)
yhat = X*w;
rss = sum((y-yhat).^2);
d = 1;
dof = n-d-1;
sigma2 = rss/dof;
stderr = sqrt(diag(sigma2*Xtest*pinv(X'*X)*Xtest'));
alpha = 0.95;
tc = tinv(1-(1-alpha)/2, dof); 
confint = [ypred-tc*stderr ypred+tc*stderr];
plot(xtest, confint(:,1), 'k:', 'linewidth', 2);
plot(xtest, confint(:,2), 'k:', 'linewidth', 2);

% plot prediction interval for y(x)
stderr = sqrt(diag(sigma2*(Xtest*pinv(X'*X)*Xtest' + 1)));
confint = [ypred-tc*stderr ypred+tc*stderr];
plot(xtest, confint(:,1), 'r--');
plot(xtest, confint(:,2), 'r--');
