%function linRegrDemoHutter()
% Same as linRegrBayesDemoHutter,
% but we just compute the MLE

[xTrain, xTest, xTrainRaw, xTestRaw, yTrain, yTestOpt, RBFcenters] = linRegDemoMakeData();

X = xTrain;
y = yTrain;
w = pinv(X'*X)*X'*y; % OLS estimate

yPredTest = xTest*w;
yPredTrain = xTrain*w;

% Plot predictive distribution
figure(2); clf
hold off
subplot(111)
plot(xTestRaw(:,1), yPredTest,  'kx-');
hold on
plot(xTestRaw(:,1),yTestOpt,'bx-');
h = plot(xTrainRaw(:,1), yPredTrain, 'gx');
h = plot(xTrainRaw(:,1), yTrain, 'ro');
set(h, 'linewidth', 3)
grid on

if 0 %~isempty(RBFcenters)
  pr = rbfBasis(xTestRaw, RBFcenters);
  figure(2);hold on;for i=1:6,plot(xTestRaw(:), pr(:,i)*5,'k-'); end
end
legend('prediction on test', 'true (noise free) test', ...
       'training fit', 'training data')
