%function linRegrDemoSimple()

seed = 1; randn('state', seed); rand('state', seed);

xTrainRaw = (-10:1:10)';
Ntrain = length(xTrainRaw);
xTrain = [ones(Ntrain,1) xTrainRaw(:)];
yTrain = 2.*xTrainRaw+3 + 5*randn(Ntrain,1);

xTestRaw = (-9.5:1:9.5)';
Ntest = length(xTestRaw);
xTest = [ones(Ntest,1) xTestRaw(:)];
yTestOpt = 2.*xTestRaw+3;


X = xTrain;
y = yTrain;
w = pinv(X'*X)*X'*y; % OLS estimate

yPredTest = xTest*w;
yPredTrain = xTrain*w;

% Plot predictive distribution
figure(2); clf
hold off
subplot(111)
h=plot(xTestRaw, yPredTest,  'kx-');set(h, 'linewidth', 2)
hold on
h=plot(xTestRaw,yTestOpt,'bx-');set(h, 'linewidth', 2)
h = plot(xTrainRaw, yPredTrain, 'rx');set(h, 'linewidth', 2)
h = plot(xTrainRaw, yTrain, 'ro');set(h, 'linewidth', 2)
for i=1:Ntrain
  h=line([xTrainRaw(i) xTrainRaw(i)], [yPredTrain(i) yTrain(i)]);
  set(h, 'linewidth', 2, 'color', 'r')
end
grid on
legend('prediction on test', 'true (noise free) test', ...
       'training fit', 'training data')

