%function [X, y] = logregGradeIRLS();
% logistic regression example on grade data from Johnson and Albert p87

stat = load('stat2.dat'); % Johnson and Albert p77 table 3.1
% stat=[pass(0/1), 1, 1, sat_score, grade in prereq]
% where the grade in prereq is encoded as A=5,B=4,C=3,D=2,F=1
y = stat(:,1);
N = length(y);
SAT = stat(:,4);
PR = stat(:,5); % pre-requisite
%X = [ones(N,1) SAT];
X = [ones(N,1) SAT PR]; 
%X = [stat(:,4) (PR==1) (PR==2) (PR==3) (PR==4) (PR==5)];

lambda = eps;
warning off
[beta, C] = logregFitFminunc(y, X, lambda);
for i=1:length(beta)
  fprintf('%s%d=%5.3f (se %5.3f)\n', 'beta', i, beta(i), sqrt(C(i,i)));
end



% visualize model fit for each training point
figure(3);clf
[junk,perm] = sort(SAT,'ascend');
N = length(perm);
for ii=1:N
  i = perm(ii);
  p = 1/(1+exp(-X(i,:)*beta));
  plot(SAT(i), p, 'o');
  hold on
  h=plot(SAT(i), y(i), 'ko');
  set(h,'markerfacecolor', 'k');
end
