% logregLaplaceDemoPred
% Plot the predictive distribution for logistic regression
% You must first run logregLaplaceDemoGirolami

figure(2);clf

% wMAP
subplot(2,2,1)
grid = W; % grid of x1, x2 valyes
pred = 1./(1+exp(-grid*wMAP));
contour(w1,w2,reshape(pred,[n,n]),30);
hold on
plot(X(find(t==1),1),X(find(t==1),2),'r.');
plot(X(find(t==0),1),X(find(t==0),2),'bo');
title('p(y=1|x, wMAP)')

% Samples
subplot(2,2,2)
plot(X(find(t==1),1),X(find(t==1),2),'r.');
hold on
plot(X(find(t==0),1),X(find(t==0),2),'bo');
predMean = zeros(n*n,1);
S = 100;
for i=1:S
  wsamp = mvnrnd(wMAP', C)';
  pred = 1./(1+exp(-grid*wsamp));
  predMean = predMean + pred;
  contour(w1,w2,reshape(pred,[n,n]),[0.5 0.5]);
end
title('decision boundary for sampled w')

% MC 
subplot(2,2,3)
predMean = predMean / S;
contour(w1,w2,reshape(predMean,[n,n]),30);
hold on
plot(X(find(t==1),1),X(find(t==1),2),'r.');
plot(X(find(t==0),1),X(find(t==0),2),'bo');
title('MC approx of p(y=1|x)')

% Numerical
subplot(2,2,4)
pred = logregPredictive(grid, wMAP, C);
contour(w1,w2,reshape(pred,[n,n]),30);
hold on
plot(X(find(t==1),1),X(find(t==1),2),'r.');
plot(X(find(t==0),1),X(find(t==0),2),'bo');
title('numerical approx of p(y=1|x)')
