% mendelsPeas
% Perform a chi-squared test on Mendel's data 

E = [312.75, 104.25, 104.25, 34.75]
O = [315, 108, 102, 31] % Rice p31
lambda = 2*sum(O .* log(O ./ E)) % 0.6184
X2 = sum( (O-E).^2 ./ E ) % 0.6042
pval = 1-chi2cdf(lambda,3) % 0.8922

O = [315, 101, 108, 32] % Wasserman p161
lambda = 2*sum(O .* log(O ./ E)) % 0.4754
X2 = sum( (O-E).^2 ./ E ) % 0.470
pval = 1-chi2cdf(lambda,3) % 0.9243
