% ridgeRegDemo
% Compare differents ways to compute the ridge estimate

n = 100; d = 2;
X = rand(n, d);
y = randn(n, 1);
lambda = 0.1;
X = standardizeCols(X')';
%w1 = ridge(y,X,lambda,0);
w1 = [X; sqrt(lambda)*eye(d)] \ [y;zeros(d,1)];
w2 = pinv(X'*X+lambda*eye(d))*X'*y;
[U,D,V] = svd(X, 'econ');
d2 = diag(D).^2;
w3 = V*diag(1./(d2 + lambda))*D*U'*y;
assert(approxeq(w1, w2))
assert(approxeq(w2, w3))

