% studentTdemo.m

figure(1);clf;
xs = -8:0.01:8;

mu0 = [0 0 0 0]; sigma20 = [1 1 1 3];
nu0 = [1 3 10 1];

for i=1:4
  p = studentTpdf(xs(:), mu0(i), sigma20(i), nu0(i));
  subplot(2,2,i)
  plot(xs, p, 'linewidth', 2)
  str=sprintf('T(%s=%2.1f, %s=%2.1f, %s=%2.1f)',...
	      '\mu_0', mu0(i), '\nu_0', nu0(i), '\sigma^2_0', sigma20(i));
  title(str)

  hold on
  p2 = normpdf(xs(:), mu0(i), sqrt(sigma20(i)));
  subplot(2,2,i)
  plot(xs, p2, 'r:', 'linewidth', 2)
end


nu = [0.01 1 5  0.01 1 5];
sigma = [1 1 1 5 5 5];
figure(1);clf
xs = -5:0.1:5;
styles = plotColors;
clear legendStr;
for i=1:length(nu)
  p = studentTpdf(xs(:), 0, sigma(i), nu(i));
  plot(xs, p, styles{i}); 
  hold on
  legendStr{i} = sprintf('t(%s=0,%s=%2.1f,%s=%2.1f)', ...
			 '\mu', '\sigma^2', sigma(i), '\nu', nu(i));
end
legend(legendStr)
title('Student T distributions')
