function x = truncatedNormalSample(m, sd, left)
% Sample from N(m, sd) such that x > left
% Based on "Simulation of truncated normal variables" by Robert (1995) 
%
% Code Written by Xuan Xuang

low = (left - m)/sd;

% Pick the best parameter lambda for translated exponetial distribution 
lambda = (low + sqrt(low^2+4))/2;
if low >= lambda
    lambda = low;
end;

u = 1; prob = 0;
while u > prob
    % z follows translated exponential distribution
    z = exprnd(1/lambda);
    z = z + low;
    % compute the acceptance probability
    if low < lambda
        prob = exp(-(lambda-z)^2/2);
    else
        prob = exp((low-lambda)^2)*exp(-(lambda-z)^2/2);
    end
    u = rand();
end
x = m + z*sd;

